# If you want only basic modules to be built,
# give rpmbuild option '--with basiconly'
%define with_basiconly %{?_with_basiconly:1}%{!?_with_basiconly:0}
%define without_basiconly %{!?_with_basiconly:1}%{?_with_basiconly:0}

%define section		free
%define name		portals-bridges

Name:		%{name}
Version:	0.3
Release:	1jpp
Epoch:		0
Summary:	Bridges for Portal Development
License:	Apache Software License 2.0
Url:		http://portals.apache.org/bridges/
Group:		Development/Libraries/Application Frameworks
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	portals-bridges-0.3-src.tar.gz
# svn export http://svn.apache.org/repos/asf/portals/bridges/tags/0.3/
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        portals-bridges-0.3-jpp-depmap.xml
Source5:        portals-bridges-LICENSE.TXT
Source6:        portals-bridges-navigation.xml
Patch0:         portals-bridges-jsf-project_xml.patch
Patch1:         portals-bridges-perl-project_xml.patch
Patch2:         portals-bridges-struts-project_xml.patch
Patch3:         portals-bridges-frameworks-project_xml.patch
Patch4:         portals-bridges-velocity-project_xml.patch
Patch5:         portals-bridges-common-project_xml.patch
Patch6:         portals-bridges-php-project_xml.patch
Patch7:         portals-bridges-0.3-GenericFrameworkPortlet.patch
BuildRequires:	maven
BuildRequires:	junit
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	ant >= 0:1.6
BuildRequires:	saxon, saxon-scripts
BuildRequires:	gnu.getopt
#
BuildRequires:	jakarta-commons-beanutils
BuildRequires:	jakarta-commons-digester
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-validator
BuildRequires:	myfaces
BuildRequires:	portlet-1.0-api
BuildRequires:	servletapi4
BuildRequires:	spring11
BuildRequires:	struts
BuildRequires:	velocity
BuildRequires:	velocity-tools
%if %{without_basiconly}
BuildRequires:	portals-jetspeed2-components
%endif
#Buildrequires:	phpportlet

Requires:	jakarta-commons-beanutils
Requires:	jakarta-commons-digester
Requires:	jakarta-commons-logging
Requires:	jakarta-commons-validator
Requires:	portals-jetspeed2-components
Requires:	myfaces
Requires:	portlet-1.0-api
Requires:	servletapi4
Requires:	spring11
Requires:	struts
Requires:	velocity
Requires:	velocity-tools

BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Portals Bridges provides support for JSR-168 compliant 
Portlet development using common web frameworks like 
Struts, JSF, PHP, Perl and Velocity. 

%package common
Summary:        Common Utils for %{name}
Group:          Development/Libraries

%description common
%{summary}.

%package velocity
Summary:        Velocity Bridge for %{name}
Group:          Development/Libraries

%description velocity
%{summary}.

%package frameworks
Summary:        Frameworks Bridge for %{name}
Group:          Development/Libraries

%description frameworks
%{summary}.

%package jsf
Summary:        JSF Bridge for %{name}
Group:          Development/Libraries

%description jsf
%{summary}.

%if %{without_basiconly}

%package php
Summary:        PHP Bridge for %{name}
Group:          Development/Libraries

%description php
%{summary}.

%package perl
Summary:        Perl Bridge for %{name}
Group:          Development/Libraries

%description perl
%{summary}.

%package struts
Summary:        Struts Bridge for %{name}
Group:          Development/Libraries

%description struts
%{summary}.

%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
cat <<EOT


If you want only basic modules to be built,
give rpmbuild option '--with basiconly'


EOT
rm -rf $RPM_BUILD_ROOT
%setup -q -n %{name}-%{version}-src
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
cp %{SOURCE5} LICENSE.TXT
#mkdir xdocs
#cp %{SOURCE6} xdocs/navigation.xml
# will not build ?
#rm -rf php

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav

%build
export DEPCAT=$(pwd)/portals-bridges-0.3-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > portals-bridges-0.3-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars maven-jelly-tags

mkdir -p .maven/repository/JPP/jars
build-jar-repository -s -p .maven/repository/JPP/jars \
commons-beanutils \
commons-digester \
commons-logging \
commons-validator \
myfaces/myfaces-jsf-api \
portlet-1.0-api \
servletapi4 \
spring11/core \
struts \
struts-el \
velocity \
velocity-tools \
phpportlet \

%if %{without_basiconly}
build-jar-repository -s -p .maven/repository/JPP/jars \
portals-jetspeed2/jetspeed-rewriter
%endif

build-jar-repository .maven/repository/JPP/jars \
gnu.getopt



export MAVEN_HOME_LOCAL=$(pwd)/.maven

pushd common
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd
pushd velocity
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd
pushd frameworks
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd
pushd jsf
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd
%if %{without_basiconly}
pushd php
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd

pushd perl
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd

pushd struts
maven \
	-Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	jar:install javadoc test:test xdoc:transform
popd

%endif

%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 \
common/target/%{name}-common-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-common-%{version}.jar
install -m 644 \
velocity/target/%{name}-velocity-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-velocity-%{version}.jar
install -m 644 \
frameworks/target/%{name}-frameworks-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-frameworks-%{version}.jar
install -m 644 \
jsf/target/%{name}-jsf-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jsf-%{version}.jar

%if %{without_basiconly}
install -m 644 \
php/target/%{name}-php-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-php-%{version}.jar
install -m 644 \
perl/target/%{name}-perl-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-perl-%{version}.jar
install -m 644 \
struts/target/%{name}-struts-%{version}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-struts-%{version}.jar
%endif

# create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/common
cp -pr common/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/common
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/velocity
cp -pr velocity/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/velocity
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/frameworks
cp -pr frameworks/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/frameworks
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jsf
cp -pr jsf/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jsf

%if %{without_basiconly}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/php
cp -pr php/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/php
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/perl
cp -pr perl/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/perl
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/struts
cp -pr struts/target/docs/apidocs/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/struts
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.TXT $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi


%files common
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-common*.jar

%files velocity
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-velocity*.jar

%files frameworks
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-frameworks*.jar

%files jsf
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-jsf*.jar

%if %{without_basiconly}
%files php
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-php*.jar

%files perl
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-perl*.jar

%files struts
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.TXT
%{_javadir}/%{name}/%{name}-struts*.jar

%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Fri Oct 21 2005 Ralph Apel <r.apel at r-apel.de> 0:0.3-1jpp
- First JPackage build
